shellCommand = Turbine.ShellCommand()
function shellCommand:Execute(command, args)
	if args=="" then
		Turbine.Shell.WriteLine("<rgb=#9ACD32>Gambit Helper:</rgb> <rgb=#DDDDDD>Available commands:</rgb>")
		Turbine.Shell.WriteLine("<rgb=#9ACD32>/gh options</rgb> <rgb=#DDDDDD>Show settings window.</rgb>")
		Turbine.Shell.WriteLine("<rgb=#9ACD32>/gh showall</rgb> <rgb=#DDDDDD>Show all gambits.</rgb>")
		Turbine.Shell.WriteLine("<rgb=#9ACD32>/gh rebuild</rgb> <rgb=#DDDDDD>Rebuilds available gambits</rgb>.")
		Turbine.Shell.WriteLine("<rgb=#9ACD32>/gh reset</rgb> <rgb=#DDDDDD>Resets default positions.</rgb>")
		Turbine.Shell.WriteLine("<rgb=#9ACD32>/gh ooc</rgb> <rgb=#DDDDDD>Toggle out of combat visibility.</rgb>")
		Turbine.Shell.WriteLine("<rgb=#9ACD32>/gh win1</rgb> <rgb=#DDDDDD>Enable/disable gambit window 1.</rgb>")
		Turbine.Shell.WriteLine("<rgb=#9ACD32>/gh win2</rgb> <rgb=#DDDDDD>Enable/disable gambit window 2.</rgb>")
	end
	
	if (_ghSettings == nil) then -- command only need to work when options gui is not open.
	if args=="showall" then
		ToggleShowAll()
	end
	
	if args=="win1" then
		ToggleWin1()
	end	
	
	if args=="win2" then
		ToggleWin2()
	end	
	
	if args=="reset" then
		Reset()
	end
	
	if args=="rebuild" then
		Rebuild()
	end
	
	if args=="options" then
		if (_ghSettings == nil) then
			_ghSettings = ZanttuxPlugins.GambitHelper.Settings()
			_ghSettings:SetVisible(true)
			UpdateDisplay()
		end
	end
		
	if args=="ooc" then
		ToggleOOC()
	end	
	end
end

function ToggleShowAll()
	_ghData.showall=not(_ghData.showall)
	if _ghData.showall then
		Turbine.Shell.WriteLine("<rgb=#9ACD32>Gambit Helper:</rgb> <rgb=#DDDDDD>All gambits are now visible.</rgb>")
	else
		Turbine.Shell.WriteLine("<rgb=#9ACD32>Gambit Helper:</rgb> <rgb=#DDDDDD>Only known gambits are now visible.</rgb>")
	end
	FilterGambitList()
	UpdateDisplay()
end

function ToggleWin1()
	_ghData.win1=not(_ghData.win1)
	if _ghData.win1 then
		Turbine.Shell.WriteLine("<rgb=#9ACD32>Gambit Helper:</rgb> <rgb=#DDDDDD>Gambit window 1 is now enabled.</rgb>")
	else
		Turbine.Shell.WriteLine("<rgb=#9ACD32>Gambit Helper:</rgb> <rgb=#DDDDDD>Gambit window 1 is now disabled.</rgb>")
	end
	UpdateDisplay()
end

function ToggleWin2()
	_ghData.win2=not(_ghData.win2)
	if _ghData.win2 then
		Turbine.Shell.WriteLine("<rgb=#9ACD32>Gambit Helper:</rgb> <rgb=#DDDDDD>Gambit window 2 is now enabled.</rgb>")
	else
		Turbine.Shell.WriteLine("<rgb=#9ACD32>Gambit Helper:</rgb> <rgb=#DDDDDD>Gambit window 2 is now disabled.</rgb>")
	end
	UpdateDisplay()
end

function Reset()
	local _displayWidth, _displayHeight = Turbine.UI.Display.GetSize();
	local _centerX = _displayWidth/2;
	local _centerY = _displayHeight/2;
	GambitWindow1:SetPosition(_centerX-360,_centerY-100)
	GambitWindow2:SetPosition(_centerX+180,_centerY-100)
	Turbine.Shell.WriteLine("<rgb=#9ACD32>Gambit Helper:</rgb> <rgb=#DDDDDD>Default positions restored.</rgb>")
end

function Rebuild()
	FilterGambitList()
	UpdateDisplay()
	Turbine.Shell.WriteLine("<rgb=#9ACD32>Gambit Helper:</rgb> <rgb=#DDDDDD>List of gambits refreshed.</rgb>")
end

function ToggleOOC()
	_ghData.ooc_visibility=not(_ghData.ooc_visibility)
	if (_ghSettings == nil) then
		GambitWindow1:SetVisible (_ghData.ooc_visibility)
		GambitWindow2:SetVisible (_ghData.ooc_visibility)
	end
	if _ghData.ooc_visibility then
		Turbine.Shell.WriteLine("<rgb=#9ACD32>Gambit Helper:</rgb> <rgb=#DDDDDD>OOC Visibility is now set ON.</rgb>")
	else
		Turbine.Shell.WriteLine("<rgb=#9ACD32>Gambit Helper:</rgb> <rgb=#DDDDDD>OOC Visibility is now set OFF.</rgb>")
	end
end

-- Save all settings
function SaveSettings()
	_ghData.x1,_ghData.y1=GambitWindow1:GetPosition() --take current location
	_ghData.x2,_ghData.y2=GambitWindow2:GetPosition() --take current location
	Turbine.PluginData.Save( Turbine.DataScope.Character, "GambitHelper", _ghData )--store everything
	Turbine.Shell.WriteLine("<rgb=#9ACD32>Gambit Helper:</rgb> <rgb=#DDDDDD>Settings saved.</rgb>") --notify player...
	if not (_ghSettings == nil) then _ghSettings = nil end
end

Turbine.Shell.AddCommand('gh', shellCommand)