function CreateDisplay()
	--this is the main window for gambits 1
	GambitWindow1 = NewWindow{x=_ghData.x1,y=_ghData.y1,width=180,height=18,colour=Turbine.UI.Color( 0.0, 0, 0,0)}
	GambitWindow1:SetMouseVisible(false)
	GambitWindow1.DragBar = Deusdictum.UI.DragBar( GambitWindow1, "Gambit Helper 1")
	GambitWindow1.DragBar:SetBarOnTop(true)
	GambitWindow1:SetVisible (false)
	
	--this is the main window for gambits 2
	GambitWindow2 = NewWindow{x=_ghData.x2,y=_ghData.y2,width=180,height=18,colour=Turbine.UI.Color( 0.0, 0, 0,0)}
	GambitWindow2:SetMouseVisible(false)
	GambitWindow2.DragBar = Deusdictum.UI.DragBar( GambitWindow2, "Gambit Helper 2")
	GambitWindow2.DragBar:SetBarOnTop(true)
	GambitWindow2:SetVisible (false)
	
	--Create listBox for images 1
	GList = Turbine.UI.ListBox();
	GList:SetPosition(0, 0)
	GList:SetParent(GambitWindow1)
	GList:SetMouseVisible (false)
			
	--Create listBox for images 2	
	GList2 = Turbine.UI.ListBox();
	GList2:SetPosition(0, 0)
	GList2:SetParent(GambitWindow2)
	GList2:SetMouseVisible (false)
			
	--ooc_visibility toggle
	GambitWindow1:SetVisible (_ghData.ooc_visibility)
	GambitWindow2:SetVisible (_ghData.ooc_visibility)
	
	-- watch combat...
	handle = AddCallback(_player, "InCombatChanged", function(sender, args )
		if not (_player:IsInCombat()) then
			GambitWindow1:SetVisible (_ghData.ooc_visibility)
			GambitWindow2:SetVisible (_ghData.ooc_visibility)
			UpdateDisplay()
		else
			GambitWindow1:SetVisible (true)
			GambitWindow2:SetVisible (true)
			UpdateDisplay()
		end
	end)
end

function AddCallback(object, event, callback)
    if (object[event] == nil) then
        object[event] = callback;
    else
        if (type(object[event]) == "table") then
            table.insert(object[event], callback);
        else
            object[event] = {object[event], callback};
        end
    end
    return callback;
end

function deepcopy(object)
    local lookup_table = {}
    local function _copy(object)
        if type(object) ~= "table" then
            return object
        elseif lookup_table[object] then
            return lookup_table[object]
        end
        local new_table = {}
        lookup_table[object] = new_table
        for index, value in pairs(object) do
            new_table[_copy(index)] = _copy(value)
        end
        return setmetatable(new_table, getmetatable(object))
    end
    return _copy(object)
end

function UpdateDisplay()
	GList:ClearItems()
	GList2:ClearItems()
		
	if (_ghSettings == nil) then -- normal draw
	--win1
	if (_ghData.win1) then
	for i=1,7 do
		if (i == 1) then
			_drawList=deepcopy(_filteredGambitList.HOT)
			AddGambit("hot.tga",GList,180,12)
		end
		if (i == 2) then
			_drawList=deepcopy(_filteredGambitList.TOT)
			AddGambit("tot.tga",GList,180,12)
		end
		if (i == 3) then
			_drawList=deepcopy(_filteredGambitList.TT)
			AddGambit("tt.tga",GList,180,12)
		end
		if (i == 4) then
			_drawList=deepcopy(_filteredGambitList.TI)
			AddGambit("ti.tga",GList,180,12)
		end
		if (i == 5) then
			_drawList=deepcopy(_filteredGambitList.AVOID)
			AddGambit("avoid.tga",GList,180,12)
		end
				
		local listlenght = tablelength(_drawList)		
		if (listlenght > 0) then
			for i,j in ipairs(_drawList) do
				if not (_ghData.selected[j[3]]) then 
					AddGambit(j[2],GList,180,18)
				else
					AddGambit("selected_"..j[2],GList,180,18)
				end
			end
		end
	end
	end
	--win2
	if (_ghData.win2) then
	for i=1,2 do
		if (i == 1) then
			_drawList=deepcopy(_filteredGambitList.DOT)
			AddGambit("d.tga",GList2,180,12)
		end
		if (i == 2) then
			_drawList=deepcopy(_filteredGambitList.MD)
			AddGambit("md.tga",GList2,180,12)
		end
					
		local listlenght = tablelength(_drawList)		
		if (listlenght > 0) then
			for i,j in ipairs(_drawList) do
				if not (_ghData.selected[j[3]]) then 
					AddGambit(j[2],GList2,180,18)
				else
					AddGambit("selected_"..j[2],GList2,180,18)
				end
			end
		end
	end
	end
	
	else -- settings open, do checklist
	
	GambitWindow1:SetVisible (true)
	GambitWindow2:SetVisible (true)
	
	for i=1,7 do
		if (i == 1) then
			_drawList=deepcopy(_filteredGambitList.HOT)
			AddGambit("hot.tga",GList,180,12)
		end
		if (i == 2) then
			_drawList=deepcopy(_filteredGambitList.TOT)
			AddGambit("tot.tga",GList,180,12)
		end
		if (i == 3) then
			_drawList=deepcopy(_filteredGambitList.TT)
			AddGambit("tt.tga",GList,180,12)
		end
		if (i == 4) then
			_drawList=deepcopy(_filteredGambitList.TI)
			AddGambit("ti.tga",GList,180,12)
		end
		if (i == 5) then
			_drawList=deepcopy(_filteredGambitList.AVOID)
			AddGambit("avoid.tga",GList,180,12)
		end
				
		local listlenght = tablelength(_drawList)		
		if (listlenght > 0) then
			for i,j in ipairs(_drawList) do
				Gambit=Turbine.UI.Lotro.CheckBox()
				Gambit:SetChecked(_ghData.selected[j[3]])
				Gambit:SetText(j[3])
				Gambit:SetFont(Turbine.UI.Lotro.Font.Verdana12)
				Gambit:SetBackground(_imageDir.."blank.tga")
				Gambit:SetForeColor(_fontColor)
				Gambit:SetSize(180,18)
				Gambit.CheckedChanged = function( sender, args )
										_ghData.selected[j[3]]=not(_ghData.selected[j[3]])
										end
				GList:AddItem(Gambit)
			end
		end
	end
	for i=1,2 do
		if (i == 1) then
			_drawList=deepcopy(_filteredGambitList.DOT)
			AddGambit("d.tga",GList2,180,12)
		end
		if (i == 2) then
			_drawList=deepcopy(_filteredGambitList.MD)
			AddGambit("md.tga",GList2,180,12)
		end
						
		local listlenght = tablelength(_drawList)		
		if (listlenght > 0) then
			for i,j in ipairs(_drawList) do
				Gambit=Turbine.UI.Lotro.CheckBox()
				Gambit:SetChecked(_ghData.selected[j[3]])
				Gambit:SetText(j[3])
				Gambit:SetFont(Turbine.UI.Lotro.Font.Verdana12)
				Gambit:SetBackground(_imageDir.."blank.tga")
				Gambit:SetForeColor(_fontColor)
				Gambit:SetSize(180,18)
				Gambit.CheckedChanged = function( sender, args )
										_ghData.selected[j[3]]=not(_ghData.selected[j[3]])
										end
				GList2:AddItem(Gambit)
			end
		end
	end
	
	end
end

function AddGambit(image,target,width,height)
	local listItem = Turbine.UI.Control()
	listItem:SetSize( width, height )
	listItem:SetBackground(_imageDir..image)
	listItem:SetMouseVisible (false)
	target:AddItem( listItem )
end

function tablelength(T)
  local count = 0
  for _ in pairs(T) do count = count + 1 end
  return count
end

-- Constructor stuff
-- Window
NewWindow = class( Turbine.UI.Lotro.Window )
function NewWindow:Constructor(options)
	Turbine.UI.Window.Constructor( self )
	self :SetPosition			( options.x,options.y)
	self :SetSize				( options.width,options.height )
	self :SetVisible			( options.visible or 1 )
	self :SetOpacity			( options.opacity or 1 )
	self :SetParent			( options.parent or nil)
	if options.mousevisible ~=nil then self :SetMouseVisible	( options.mousevisible) end
	if options.image ~=nil then 	self :SetBackground ( options.image) else self :SetBackColor ( options.colour or Turbine.UI.Color( 1, 0, 0)) end
end