Settings = class( Turbine.UI.Window );

function Settings:Constructor()
	Turbine.UI.Lotro.Window.Constructor( self );
	
	self:SetPosition(_ghData.sx, _ghData.sy);
	self:SetSize(400, 250);
	self:SetText("Gambit Helper Options");
		
	-- general settings
	_labelGeneral = Turbine.UI.Label()
    _labelGeneral:SetParent(self)
    _labelGeneral:SetPosition(30, 30)
    _labelGeneral:SetSize(340, 20)
	_labelGeneral:SetFont(Turbine.UI.Lotro.Font.TrajanPro14)
	_labelGeneral:SetForeColor(_fontColorHeader)
    _labelGeneral:SetText("-- MISC OPTIONS --")
	_labelGeneral:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter )
		
	-- ooc visibility
	_ooc = Turbine.UI.Lotro.CheckBox()
	_ooc:SetParent(self)
	_ooc:SetSize(380, 20)
	_ooc:SetPosition(10, 60)
	_ooc:SetFont(Turbine.UI.Lotro.Font.Verdana12)
	_ooc:SetForeColor(_fontColor)
	_ooc:SetText(" Show gambit windows out of combat.")
	_ooc:SetChecked(_ghData.ooc_visibility)
	_ooc.CheckedChanged = function( sender, args )
							ToggleOOC()
						 end

	-- win 1
	_win1 = Turbine.UI.Lotro.CheckBox()
	_win1:SetParent(self)
	_win1:SetSize(360, 20)
	_win1:SetPosition(10, 80)
	_win1:SetFont(Turbine.UI.Lotro.Font.Verdana12)
	_win1:SetForeColor(_fontColor)
	_win1:SetText(" Gambit window 1 enabled")
	_win1:SetChecked(_ghData.win1)
	_win1.CheckedChanged = function( sender, args )
							ToggleWin1()
						 end	
	
	-- win 2
	_win2 = Turbine.UI.Lotro.CheckBox()
	_win2:SetParent(self)
	_win2:SetSize(360, 20)
	_win2:SetPosition(10, 100)
	_win2:SetFont(Turbine.UI.Lotro.Font.Verdana12)
	_win2:SetForeColor(_fontColor)
	_win2:SetText(" Gambit window 2 enabled")
	_win2:SetChecked(_ghData.win2)
	_win2.CheckedChanged = function( sender, args )
							ToggleWin2()
						 end
	
	-- showall
	_all = Turbine.UI.Lotro.CheckBox()
	_all:SetParent(self)
	_all:SetSize(380, 20)
	_all:SetPosition(10, 120)
	_all:SetFont(Turbine.UI.Lotro.Font.Verdana12)
	_all:SetForeColor(_fontColor)
	_all:SetText(" Show all gambits")
	_all:SetChecked(_ghData.showall)
	_all.CheckedChanged = function( sender, args )
							ToggleShowAll()
						 end
						 
	-- actions
	_labelActions = Turbine.UI.Label()
    _labelActions:SetParent(self)
    _labelActions:SetPosition(10, 160)
    _labelActions:SetSize(380, 20)
	_labelActions:SetFont(Turbine.UI.Lotro.Font.TrajanPro14)
	_labelActions:SetForeColor(_fontColorHeader)
    _labelActions:SetText("-- ACTIONS --")
    _labelActions:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter )

	-- reset positions
	_resetButton = Turbine.UI.Lotro.Button()
	_resetButton:SetParent(self)
	_resetButton:SetSize(100, 20)
	_resetButton:SetPosition(10, 190)
	_resetButton:SetFont(Turbine.UI.Lotro.Font.Verdana12)
	_resetButton:SetForeColor(_fontColor)
	_resetButton:SetText("Reset")
	_resetButton.Click= function (sender, args)
						Reset()
						end
						
	_labelResetButton = Turbine.UI.Label()
    _labelResetButton:SetParent(self)
    _labelResetButton:SetPosition(120, 194)
    _labelResetButton:SetSize(270, 20)
	_labelResetButton:SetFont(Turbine.UI.Lotro.Font.Verdana12)
	_labelResetButton:SetForeColor(_fontColor)
    _labelResetButton:SetText("Reset default window positions")
	
	-- rebuild
	_rebuildButton = Turbine.UI.Lotro.Button()
	_rebuildButton:SetParent(self)
	_rebuildButton:SetSize(100, 20)
	_rebuildButton:SetPosition(10, 210)
	_rebuildButton:SetFont(Turbine.UI.Lotro.Font.Verdana12)
	_rebuildButton:SetForeColor(_fontColor)
	_rebuildButton:SetText("Rebuild")
	_rebuildButton.Click= function (sender, args)
						Rebuild()
						end
						
	_labelRebuildButton = Turbine.UI.Label()
    _labelRebuildButton:SetParent(self)
    _labelRebuildButton:SetPosition(120, 214)
    _labelRebuildButton:SetSize(270, 20)
	_labelRebuildButton:SetFont(Turbine.UI.Lotro.Font.Verdana12)
	_labelRebuildButton:SetForeColor(_fontColor)
    _labelRebuildButton:SetText("Rebuild list of gambits (use after leveling)")
   	  
	-- save on exit
	self.Closed = function( sender, args )
		_ghData.sx,_ghData.sy=_ghSettings:GetPosition()
		SaveSettings()
		GambitWindow1:SetVisible (_ghData.ooc_visibility)
		GambitWindow2:SetVisible (_ghData.ooc_visibility)
		UpdateDisplay()
	end
end